/*
 * URL Handler
 * 
 * Copyright (c) RegExLab.com
 * 
 * 2007.06.18 Chongqing China.
 */
package com.regexlab.j2e;

import java.io.*;
import java.net.*;

/**
 * URL Handler
 * 
 * @author sswater shi
 */
public class Handler extends URLStreamHandler
{
    protected URLConnection openConnection(URL url) throws IOException
    {
        final String resource = url.toString();

        return new URLConnection(url)
        {
            public void connect() { }

            public InputStream getInputStream() {
                return new ByteArrayInputStream(loadResourceData(resource));
            }
        };
    }

    protected native byte [] loadResourceData(String resource);

    static
    {
        String s = System.getProperty("j2e.app.path");
        if (s != null)
            System.load(s);
    }
}
