package com.regexlab.test;

import javax.swing.*;
import com.regexlab.j2e.SystemTray;
import com.regexlab.j2e.SystemTrayCallback;
import com.regexlab.j2e.SystemTrayMenu;
import java.awt.*;

public class TraysDemo extends JFrame
{
    private static final long serialVersionUID = 1L;

    private JPanel jContentPane = null;
    private JCheckBox jCheckIcon1 = null;
    private JCheckBox jCheckIcon2 = null;
    private JButton jButtonIcon1 = null;
    
    // SystemTray
    SystemTray tray98 = new SystemTray(1, "hello, this is tip");  //  @jve:decl-index=0:
    SystemTray tray2k = new SystemTray(1, "hello", "this is win 2k style info", "title", SystemTray.INFOTYPE_INFO);
    SystemTrayMenu menu = null;

    Thread m_changing = null;  //  @jve:decl-index=0:

    /**
     * This method initializes jCheckIcon1	
     * 	
     * @return javax.swing.JCheckBox	
     */
    private JCheckBox getJCheckIcon1()
    {
        if (jCheckIcon1 == null)
        {
            jCheckIcon1 = new JCheckBox();
            jCheckIcon1.setText("Icon 1");
            jCheckIcon1.addItemListener(new java.awt.event.ItemListener() {
                public void itemStateChanged(java.awt.event.ItemEvent e)
                {
                    if(e.getStateChange() == java.awt.event.ItemEvent.SELECTED)
                    {
                        jButtonIcon1.setEnabled(true);
                        tray98.Show();
                    }
                    else
                    {
                        jButtonIcon1.setEnabled(false);
                        tray98.Hide();
                        StopMove();
                    }
                }
            });
        }
        return jCheckIcon1;
    }

    /**
     * This method initializes jCheckIcon2	
     * 	
     * @return javax.swing.JCheckBox	
     */
    private JCheckBox getJCheckIcon2()
    {
        if (jCheckIcon2 == null)
        {
            jCheckIcon2 = new JCheckBox();
            jCheckIcon2.setText("Icon 2");
            jCheckIcon2.addItemListener(new java.awt.event.ItemListener() {
                public void itemStateChanged(java.awt.event.ItemEvent e)
                {
                    if(e.getStateChange() == java.awt.event.ItemEvent.SELECTED)
                    {
                        tray2k.Show();
                    }
                    else
                    {
                        tray2k.Hide();
                    }
                }
            });
        }
        return jCheckIcon2;
    }

    /**
     * This method initializes jButtonIcon1	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getJButtonIcon1()
    {
        if (jButtonIcon1 == null)
        {
            jButtonIcon1 = new JButton();
            jButtonIcon1.setEnabled(false);
            jButtonIcon1.setText("Start");
            jButtonIcon1.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e)
                {
                    if(m_changing != null)
                    {
                        StopMove();
                    }
                    else
                    {
                        StartMove();
                    }
                }
            });
        }
        return jButtonIcon1;
    }

    protected void StartMove()
    {
        if(m_changing == null)
        {
            jButtonIcon1.setText("Stop");
            
            m_changing = new Thread(new DynamicIcon1(tray98));
            m_changing.start();
        }
    }
    
    protected void StopMove()
    {
        if(m_changing != null)
        {
            jButtonIcon1.setText("Start");
            
            m_changing.interrupt();
            m_changing = null;
            
            tray98.Change(0, "Stopped.");
        }
    }
    
    /**
     * @param args
     */
    public static void main(String[] args)
    {
        TraysDemo thisClass = new TraysDemo();
        thisClass.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        thisClass.setVisible(true);
    }

    /**
     * This is the default constructor
     */
    public TraysDemo()
    {
        super();
        initialize();
        
        final TraysDemo main = this;
        
        SystemTray.setSystemTrayCallback(new SystemTrayCallback(){
            public void OnMenuCommand(int menuid)
            {
                if(menuid == 1)
                {
                    JOptionPane.showMessageDialog(main, "Hello");
                }
                else if(menuid == 2)
                {
                    StartMove();
                }
                else if(menuid == 3)
                {
                    StopMove();
                }
                else if(menuid == 100)
                {
                    StopMove();
                    main.dispose();
                }
            }
            public void OnMouseClick(SystemTray tray, int mouseEvent)
            {
                if(mouseEvent == SystemTray.LEFT_DOUBLE_CLICK)
                {
                    JOptionPane.showMessageDialog(main, "Hello, you have left double clicked!");
                }
                else if(mouseEvent == SystemTray.RIGHT_CLICK)
                {
                    if(menu == null)
                    {
                        SystemTrayMenu submenu = new SystemTrayMenu();
                        submenu.Append("Say &Hello also", 1);
                        submenu.Append("S&top", 3);
                        
                        menu = new SystemTrayMenu();
                        menu.Append("Say &Hello", 1);
                        menu.Append("&Move", 2);
                        menu.Append("This is submenu", submenu);
                        menu.AppendSeparator();
                        menu.Append("E&xit", 100);
                    }
                    
                    menu.Popup();
                }
            }
        });
    }

    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize()
    {
        this.setSize(300, 200);
        this.setContentPane(getJContentPane());
        this.setTitle("TraysDemo");
        this.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent e)
            {
                StopMove();
            }
        });
        
        // center window
        Toolkit    tk  = Toolkit.getDefaultToolkit();

        int Width  = tk.getScreenSize().width;
        int Height = tk.getScreenSize().height;
        
        this.setLocation((Width - this.getWidth()) / 2, (Height - this.getHeight()) / 2);
    }

    /**
     * This method initializes jContentPane
     * 
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane()
    {
        if (jContentPane == null)
        {
            GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
            gridBagConstraints2.gridx = 1;
            gridBagConstraints2.gridy = 0;
            GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
            gridBagConstraints1.gridx = 0;
            gridBagConstraints1.gridy = 1;
            GridBagConstraints gridBagConstraints = new GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 0;
            jContentPane = new JPanel();
            jContentPane.setLayout(new GridBagLayout());
            jContentPane.add(getJCheckIcon1(), gridBagConstraints);
            jContentPane.add(getJButtonIcon1(), gridBagConstraints2);
            jContentPane.add(getJCheckIcon2(), gridBagConstraints1);
        }
        return jContentPane;
    }

    class DynamicIcon1 implements Runnable
    {
        SystemTray m_tray = null;
        
        DynamicIcon1(SystemTray tray)
        {
            m_tray = tray;
        }
        
        public void run()
        {
            try
            {
                if(m_tray != null)
                {
                    for(;;)
                    for(int i=0; i<10; i++)
                    {
                        m_tray.Change(i + 1, "Moving...");

                        Thread.sleep(200);
                    }
                }
            }
            catch(InterruptedException ie)
            {
            }
        }
    }
}
